SoPendulum(3IV)

NAME
SoPendulum — animated oscillating rotation node

INHERITS FROM
SoBase > SoFieldContainer > SoNode > SoTransformation > SoRotation > SoPendulum

SYNOPSIS
#include <Inventor/nodes/SoPendulum.h>

Fields from class SoPendulum:

SoSFRotation
rotation0
SoSFRotation
rotation1
SoSFFloat
speed
SoSFBool
on

Fields from class SoRotation:

SoSFRotation
rotation

Methods from class SoPendulum:

SoPendulum()
static SoType
getClassTypeId()

Methods from class SoNode:

void
setOverride(SbBool state)
SbBool
isOverride() const
SoNode *
copy(SbBool copyConnections = FALSE) const
virtual SbBool
affectsState() const
static SoNode *
getByName(const SbName &name)
static int
getByName(const SbName &name, SoNodeList &list)

Methods from class SoFieldContainer:

void
setToDefaults()
SbBool
hasDefaultValues() const
SbBool
fieldsAreEqual(const SoFieldContainer *fc) const
void
copyFieldValues(const SoFieldContainer *fc, SbBool copyConnections = FALSE)
SbBool
set(const char *fieldDataString)
void
get(SbString &fieldDataString)
virtual int
getFields(SoFieldList &resultList) const
virtual SoField *
getField(const SbName &fieldName) const
SbBool
getFieldName(const SoField *field, SbName &fieldName) const
SbBool
isNotifyEnabled() const
SbBool
enableNotify(SbBool flag)

Methods from class SoBase:

void
ref()
void
unref() const
void
unrefNoDelete() const
void
touch()
virtual SoType
getTypeId() const
SbBool
isOfType(SoType type) const
virtual void
setName(const SbName &name)
virtual SbName
getName() const

DESCRIPTION
The SoPendulum class is derived from SoRotation, so it applies a rotation to the current transformation. Using engines connected to the realTime global field, the rotation value is animated over time between two fixed rotations, achieving the effect of a swinging pendulum. The period of the swing can be adjusted by changing the speed field. The current rotation at any time is available in the rotation field, inherited from SoRotation

FIELDS
SoSFRotation
rotation0
SoSFRotation
rotation1
These define the two fixed rotations that are interpolated to create the pendular motion.

SoSFFloat
speed
Defines the speed of the pendulum, in cycles per second.

SoSFBool
on
Allows applications to enable or disable the motion easily.

METHODS

SoPendulum()
Creates a pendulum node with default settings.

static SoType
getClassTypeId()
Returns type identifier for this class.

ACTION BEHAVIOR
SoGLRenderAction, SoCallbackAction, SoGetBoundingBoxAction, SoRayPickAction
Concatenates interpolated rotation value with the current transformation matrix.

SoGetMatrixAction
Returns transformation matrix specified by the interpolated rotation.

FILE FORMAT/DEFAULTS
Pendulum {
rotation	0 0 1  0
rotation0	0 0 1  0
rotation1	0 0 1  0
speed	1
on	TRUE
}

SEE ALSO
SoRotor, SoShuttle